/*================================================================
 HMGAPPLICATION function
 ================================================================*/

#include "hmg-include.ch"

PROCEDURE HMGStart()

 IF !__mvEXIST( "windows" )
  __mvPUBLIC( "windows" )
 ENDIF

 windows := HMGAPPLICATION():New()

RETURN

/*================================================================
 HMGAPPLICATION class
 ================================================================*/
#include "hbclass.ch"
#include "common.ch"

CLASS HMGAPPLICATION FROM HMGBASEINIT

   DATA aChilds                                   INIT {}
   DATA oQtObject                                 INIT NIL
   DATA cName                                     INIT "windows"

// Methods
   METHOD AddChild
   METHOD AddData
   METHOD New
   METHOD Quit
   METHOD Start
   METHOD RegisterResource
   METHOD UnRegisterResources

// Properties
   METHOD ChildList                               INLINE ::aChilds
   METHOD Name                                    INLINE ::cName
   METHOD QtObject                                INLINE ::oQtObject

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 AddChild
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:AddChild( oObject )

   AADD( ::aChilds, oObject )

RETURN NIL

/*---------------------------------------------------------------
 AddData
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:AddData( cObjName, oObject )

   __objAddData( Self, cObjName )

   ::&cObjName := oObject

RETURN NIL

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:New()

   ::Start()

RETURN Self

/*---------------------------------------------------------------
 Start
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:Start()

   LOCAL cPath, cFile, cExt
   LOCAL QtPluginPath

   hb_FnameSplit( hb_Progname(), @cPath, @cFile, @cExt )

// in this way you can put plugins dll in <ExePath>\Qt\Plugins and Qt try to find here and qt.conf it's not required
// ie <ExePath>\Qt\Plugins\ImageFormats\qico4.dll
// TODO take this as a parameter
   QtPluginPath := cPath + "Qt" + hb_ps() + "plugins"


   IF ::lQtStarted == .F.
      ::lQtStarted     := .T.
      ::sQtApplication := QApplication()
      ::sQtResource    := QResource()
      ::sQtLocale      := QLocale()
// to get path list :libraryPaths()
      ::sQtApplication:addLibraryPath( QtPluginPath )

      ::oDefaultParent := Self
      ::oCurrentParent := Self
      ::oQtObject      := ::sQtApplication:DeskTop()
// register default resource file with exe name
      ::RegisterResource( cFile )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Quit
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:Quit()

   IF ::lQtStarted == .T.
      ::UnRegisterResources()
      ::sQtApplication:Exit()
      ::sQtApplication:Quit()
      IF __mvEXIST( "windows" )
         __mvXRELEASE( "windows" )
      ENDIF
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 RegisterResource
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:RegisterResource( cResource )

   LOCAL cResFileName := "HBQTRES_" + ALLTRIM( cResource ) + "()"

   IF ::lQtStarted == .T.
      IF TYPE( cResFileName ) == "UI"
         IF ::sQtResource:registerResource_1( &cResFileName ) == .T.
            AADD( ::aQtResource, cResFileName )
         ENDIF
      ENDIF
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 UnRegisterResources
 ---------------------------------------------------------------*/
METHOD HMGAPPLICATION:UnRegisterResources()

   LOCAL nI, cResFileName

   IF ::lQtStarted == .T.
      FOR nI := 1 TO LEN( ::aQtResource )
         cResFileName := ::aQtResource[ nI ]
         ::sQtResource:unregisterResource_1( &cResFileName )
      NEXT nI
      ASIZE( ::aQtResource, 0 )
   ENDIF

RETURN NIL
