/*================================================================
 HMGBASEOBJ class
 ================================================================*/
#include "hmg-include.ch"
#include "hbqtgui.ch"
#include "hbclass.ch"
#include "common.ch"

CLASS HMGBASEOBJ

   DATA oQtObject                                 INIT NIL

// generic Data
   DATA lActivated                                INIT .F.
   DATA cCaption                                  INIT NIL
   DATA nCol                                      INIT NIL
   DATA aChilds                                   INIT {}
   DATA nDirection                                INIT Qt_AlignAbsolute
   DATA oFont                                     INIT NIL
   DATA cFontName                                 INIT NIL
   DATA nFontSize                                 INIT NIL
   DATA lFontBold                                 INIT NIL
   DATA lFontItalic                               INIT NIL
   DATA lFontUnderLine                            INIT NIL
   DATA lFontStrikeout                            INIT NIL
   DATA nFormType                                 INIT NIL
   DATA nHalign                                   INIT Qt_AlignHCenter
   DATA nHeight                                   INIT NIL
   DATA cIcon                                     INIT NIL
   DATA cName                                     INIT NIL
   DATA bOnGotFocus                               INIT NIL
   DATA bOnInit                                   INIT NIL
   DATA bOnInteractiveClose                       INIT NIL
   DATA bOnLostFocus                              INIT NIL
   DATA bOnMaxiMize                               INIT NIL
   DATA bOnMiniMize                               INIT NIL
   DATA bOnMouseClick                             INIT NIL
   DATA bOnMouseDrag                              INIT NIL
   DATA bOnMouseMove                              INIT NIL
   DATA bOnNotifyClick                            INIT NIL
   DATA bOnPaint                                  INIT NIL
   DATA bOnRelease                                INIT NIL
   DATA bOnScrollDown                             INIT NIL
   DATA bOnScrollLeft                             INIT NIL
   DATA bOnScrollRight                            INIT NIL
   DATA bOnScrollUp                               INIT NIL
   DATA bOnSize                                   INIT NIL
   DATA oParent                                   INIT NIL
   DATA nRow                                      INIT NIL
   DATA cStyleSheet                               INIT NIL
   DATA oSystemTrayIcon                           INIT NIL
   DATA cTitle                                    INIT NIL
   DATA nValign                                   INIT Qt_AlignVCenter
   DATA nWidth                                    INIT NIL

// Methods
   METHOD AddChild
   METHOD AddData
   METHOD Center
   METHOD CreatePendingChildControls

// Properties
   METHOD Caption                                 SETGET
   METHOD ChildList                               INLINE ::aChilds
   METHOD Col                                     SETGET
   METHOD Font                                    SETGET
   METHOD FontName                                SETGET
   METHOD FontSize                                SETGET
   METHOD FontBold                                SETGET
   METHOD FontItalic                              SETGET
   METHOD FontUnderLine                           SETGET
   METHOD FontStrikeout                           SETGET
   METHOD FormType                                SETGET
   METHOD Height                                  SETGET
   METHOD Icon                                    SETGET
   METHOD Name                                    SETGET
   METHOD OnGotFocus                              SETGET
   METHOD OnInit                                  SETGET
   METHOD OnInteractiveClose                      SETGET
   METHOD OnLostFocus                             SETGET
   METHOD OnMaxiMize                              SETGET
   METHOD OnMiniMize                              SETGET
   METHOD OnMouseClick                            SETGET
   METHOD OnMouseDrag                             SETGET
   METHOD OnMouseMove                             SETGET
   METHOD OnNotifyClick                           SETGET
   METHOD OnPaint                                 SETGET
   METHOD OnRelease                               SETGET
   METHOD OnScrollDown                            SETGET
   METHOD OnScrollLeft                            SETGET
   METHOD OnScrollRight                           SETGET
   METHOD OnScrollUp                              SETGET
   METHOD OnSize                                  SETGET
   METHOD QtObject                                INLINE ::oQtObject
   METHOD Row                                     SETGET
   METHOD StyleSheet                              SETGET
   METHOD Title                                   SETGET
   METHOD Width                                   SETGET

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 AddChild
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:AddChild( oObject )

   AADD( ::aChilds, oObject )

RETURN NIL

/*---------------------------------------------------------------
 AddData
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:AddData( cName, oObject )

   __objAddData( Self, cName )

   ::&cName := oObject

RETURN NIL

/*---------------------------------------------------------------
 CreatePendingChildControls
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:CreatePendingChildControls()

   LOCAL nI

   FOR nI := 1 TO LEN( ::aChilds )
// TODO check if :Activate() method exists
      ::aChilds[nI]:Activate()
   NEXT nI

RETURN NIL

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 Caption
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Caption( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cCaption
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cCaption := cArg1
      ::oQTObject:setText( ::cCaption )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Center
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Center()

   LOCAL nFreeW, nFreeH

   nFreeW := GetFreeWidth( ::oParent:QtObject() )
   nFreeH := GetFreeHeight( ::oParent:QtObject() )
   ::nRow := INT( ( nFreeH - ::nHeight ) / 2 )
   ::nCol := INT( ( nFreeW - ::nWidth ) / 2 )
   ::oQTObject:move( ::nCol, ::nRow )

RETURN NIL

/*---------------------------------------------------------------
 Col
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Col( nArg1 )

   IF PCOUNT() == 0
      RETURN ::Col
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nCol := nArg1
      ::nRow := IF( VALTYPE( ::nRow) == "N", ::nRow, ::oQTObject:y() )
      ::oQTObject:move( ::nCol, ::nRow )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Font
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Font( oArg1 )

   IF PCOUNT() == 0
      RETURN ::oFont
   ELSEIF VALTYPE( oArg1 ) == "O"
      ::oFont := oArg1
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontName
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontName( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cFontName
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cFontName := cArg1
      ::oFont:SetFamily( ::cFontName )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontSize
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontSize( nArg1 )

   IF PCOUNT() == 0
      RETURN ::nFontSize
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nFontSize := nArg1
      ::oFont:SetPointSize( ::nFontSize )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontBold
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontBold( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lFontBold
   ELSEIF VALTYPE( lArg1 ) == "L"
      ::lFontBold := lArg1
      ::oFont:SetBold( ::lFontBold )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontItalic
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontItalic( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lFontItalic
   ELSEIF VALTYPE( lArg1 ) == "L"
      ::lFontItalic := lArg1
      ::oFont:SetItalic( ::lFontItalic )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontUnderLine
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontUnderLine( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lFontUnderLine
   ELSEIF VALTYPE( lArg1 ) == "L"
      ::lFontUnderLine := lArg1
      ::oFont:SetUnderLine( ::lFontUnderline )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontStrikeOut
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FontStrikeOut( lArg1 )

   IF PCOUNT() == 0
      RETURN ::lFontStrikeOut
   ELSEIF VALTYPE( lArg1 ) == "L"
      ::lFontStrikeOut := lArg1
      ::oFont:SetStrikeOut( ::lFontStrikeout )
      ::oQTObject:SetFont( ::oFont )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FormType
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:FormType( nArg1 )

   IF PCOUNT() == 0
      RETURN ::nFormType
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nFormType := nArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Height
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Height( nArg1 )

   IF PCOUNT() == 0
      RETURN ::nHeight
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nHeight := nArg1
      ::nWidth := IF( VALTYPE( ::nWidth ) == "N", ::nWidth, ::oQTObject:Width() )
      ::oQTObject:resize( ::nWidth, ::nHeight )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Icon (windowIcon)
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Icon( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cIcon
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cIcon := cArg1
      ::oQTObject:setWindowIcon( ::cIcon )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Name
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Name( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cName
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cName := cArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnGotFocus
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnGotFocus( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnGotFocus
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnGotFocus := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnInit
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnInit( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnInit
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnInit := bArg1
      ::oQTObject:connect( QEvent_Show , {|| EVAL( ::bOnInit ) } )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnInteractiveClose
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnInteractiveClose( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnInteractiveClose
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnInteractiveClose := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnLostFocus
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnLostFocus( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnLostFocus
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnLostFocus := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnMaxiMize
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnMaxiMize( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnMaxiMize
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnMaxiMize := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnMiniMize
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnMiniMize( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnMiniMize
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnMiniMize := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnMouseClick
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnMouseClick( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnMouseClick
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnMouseClick := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnMouseDrag
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnMouseDrag( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnMouseDrag
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnMouseDrag := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnMouseMove
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnMouseMove( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnMouseMove
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnMouseMove := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnNotifyClick
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnNotifyClick( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnNotifyClick
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnNotifyClick := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnPaint
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnPaint( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnPaint
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnPaint := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnRelease
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnRelease( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnRelease
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnRelease := bArg1
      IF ::nFormType == WND_MAIN
         ::oQTObject:disconnect( QEvent_Close )
         IF VALTYPE( ::bOnRelease ) == "B"
            ::oQTObject:connect( QEvent_Close , {|| EVAL( ::bOnRelease ), ::sQtApplication:Quit() } )
         ELSE
            ::oQTObject:connect( QEvent_Close , {|| ::sQtApplication:Quit() } )
         ENDIF
      ELSEIF ::nFormType == WND_MODAL
         ::oQTObject:disconnect( QEvent_Close )
         IF VALTYPE( ::bOnRelease ) == "B"
            ::oQTObject:connect( QEvent_Close , {|| EVAL( ::bOnRelease ), ::oQTObject:Exit(), ::oQTObject:Quit() } )
         ELSE
            ::oQTObject:connect( QEvent_Close , {|| ::oQTObject:Exit(), ::oQTObject:Quit() } )
         ENDIF
      ENDIF
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnScrollDown
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnScrollDown( bArg1 )

   IF PCOUNT() == 0
      RETURN ::bOnScrollDown
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnScrollDown := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnScrollLeft
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnScrollLeft( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnScrollLeft
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnScrollLeft := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnScrollRight
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnScrollRight( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnScrollRight
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnScrollRight := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnScrollUp
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnScrollUp( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnScrollUp
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnScrollUp := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnSize
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:OnSize( bArg1 )

   IF PCOUNT() == 0
     RETURN ::bOnSize
   ELSEIF VALTYPE( bArg1 ) == "B"
      ::bOnSize := bArg1
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Row
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Row( nArg1 )

   IF PCOUNT() == 0
      RETURN ::nRow
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nRow := nArg1
      ::nCol := IF( VALTYPE( ::nCol) == "N", ::nCol, ::oQTObject:x() )
      ::oQTObject:move( ::nCol, ::nRow )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 StyleSheet
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:StyleSheet( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cStyleSheet
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cStyleSheet := cArg1
      ::oQTObject:setStyleSheet( ::cStyleSheet )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Title
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Title( cArg1 )

   IF PCOUNT() == 0
      RETURN ::cTitle
   ELSEIF VALTYPE( cArg1 ) == "C"
      ::cTitle          := cArg1
      ::oQtObject:setWindowTitle( ::cTitle )
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Width
 ---------------------------------------------------------------*/
METHOD HMGBASEOBJ:Width( nArg1 )

   IF PCOUNT() == 0
      RETURN ::nWidth
   ELSEIF VALTYPE( nArg1 ) == "N"
      ::nWidth := nArg1
      ::nHeight := IF( VALTYPE( ::nHeight ) == "N", ::nHeight, ::oQTObject:Height() )
      ::oQTObject:resize( ::nWidth, ::nHeight )
   ENDIF

RETURN NIL
