/*================================================================
 HMGLABLE class
 ================================================================*/
#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"

CLASS HMGLABLE FROM HMGBASEOBJ, HMGBASEINIT

// Methods
   METHOD Activate
   METHOD Create
   METHOD New

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 Activate
 ---------------------------------------------------------------*/
METHOD HMGLABLE:Activate()

// TO prevent more time activation
   IF ::lActivated == .T.
      RETURN NIL
   ENDIF

   ::Create()
   ::lActivated := .T.

// Show QtObject
   ::oQTObject:Show()

RETURN NIL

/*---------------------------------------------------------------
 Create
 ---------------------------------------------------------------*/
METHOD HMGLABLE:Create()

// TO prevent more time creation
   IF ::lActivated == .T.
      RETURN NIL
   ENDIF

// TO prevent use without QT starting
   IF ::lQtStarted == .F.
      HMGAPPLICATION():Start()
   ENDIF

// TODO HMG errors
   IF ::lStdError == .T.
      ::sQtApplication:Exit()
      ::sQtApplication:Quit()
// TODO HmgStdErr LOG
      QUIT
   ENDIF

// add HmgObject to its parent
   ::oParent:AddData( ::cName , Self )

RETURN NIL

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD HMGLABLE:New( oParent )

// set-up a default name
   ::cName          := '_HMG_OBJECT_' + hb_ntos( ::nObjectCounter++ )
// set-up parent in this order: parameter, current or default (last one is Qt QApplication():DeskTop()
   ::oParent := IF( hb_IsObject( oParent ), oParent, IF( hb_IsObject( ::oCurrentParent ), ::oCurrentParent, ::oDefaultParent ) )
// add this HMG object to its parent
   ::oParent:AddChild( Self )
// create QT object with its parent
   ::oQtObject := QLabel( ::oParent:Qtobject() )
// inherit font
   ::oFont     := ::oParent:QtObject:Font()

RETURN Self

/*................................................................
 Properties - section
 ................................................................*/
