/*================================================================
 HMGMISC functions
 ================================================================*/
#include "hbqtgui.ch"

FUNCTION GetWidth( oQtWidget )

   LOCAL oMisc := HMGMISC():New()
   LOCAL nReturned := oMisc:GetWidth( oQtWidget )
   
   hb_gcall()

RETURN nReturned

FUNCTION GetHeight( oQtWidget )

   LOCAL oMisc := HMGMISC():New()
   LOCAL nReturned := oMisc:GetHeight( oQtWidget )
   
   hb_gcall()

RETURN nReturned

FUNCTION GetFreeWidth( oQtWidget )

   LOCAL oMisc := HMGMISC():New()
   LOCAL nReturned := oMisc:GetFreeWidth( oQtWidget )
   
   hb_gcall()

RETURN nReturned

FUNCTION GetFreeHeight( oQtWidget )

   LOCAL oMisc := HMGMISC():New()
   LOCAL nReturned := oMisc:GetFreeHeight( oQtWidget )
   
   hb_gcall()

RETURN nReturned

/*================================================================
 HMGMISC class
 ================================================================*/
#include "hbclass.ch"
#include "common.ch"

CLASS HMGMISC FROM HMGBASEOBJ, HMGBASEINIT

// Methods
   METHOD GetFreeHeight
   METHOD GetFreeWidth
   METHOD GetHeight
   METHOD GetWidth

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 GetFreeHeight
 ---------------------------------------------------------------*/
METHOD HMGMISC:GetFreeHeight( oWidget )

   LOCAL nReturned := 0
   
   IF ::lQtStarted == .T.
      nReturned := IF( hb_isobject( oWidget ) == .T., oWidget:availableGeometry( -1 ):height(), QDesktopWidget():availableGeometry( -1 ):height() )
   ENDIF

RETURN nReturned

/*---------------------------------------------------------------
 GetFreeWidth
 ---------------------------------------------------------------*/
METHOD HMGMISC:GetFreeWidth( oWidget )

   LOCAL nReturned := 0
   
   IF ::lQtStarted == .T.
      nReturned := IF( hb_isobject( oWidget ) == .T., oWidget:availableGeometry( -1 ):width(), QDesktopWidget():availableGeometry( -1 ):width() )
   ENDIF

RETURN nReturned

/*---------------------------------------------------------------
 GetHeight
 ---------------------------------------------------------------*/
METHOD HMGMISC:GetHeight( oWidget )

   LOCAL nReturned := 0
   
   IF ::lQtStarted == .T.
      nReturned := IF( hb_isobject( oWidget ) == .T., oWidget:screenGeometry( -1 ):height(), QDesktopWidget():screenGeometry( -1 ):height() )
   ENDIF

RETURN nReturned

/*---------------------------------------------------------------
 GetWidth
 ---------------------------------------------------------------*/
METHOD HMGMISC:GetWidth( oWidget )

   LOCAL nReturned := 0
   
   IF ::lQtStarted == .T.
      nReturned := IF( hb_isobject( oWidget ) == .T., oWidget:screenGeometry( -1 ):width(), QDesktopWidget():screenGeometry( -1 ):width() )
   ENDIF

RETURN nReturned
