/*================================================================
 HMGWINDOW class
 ================================================================*/
#include "hmg-include.ch"
#include "hbqtgui.ch"
#include "hbclass.ch"
#include "common.ch"

CLASS HMGWINDOW FROM HMGBASEOBJ, HMGBASEINIT

// Methods
   METHOD Activate
   METHOD Create
   METHOD EndWindow
   METHOD New

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 Activate
 ---------------------------------------------------------------*/
METHOD HMGWINDOW:Activate()

// TO prevent more time activation
   IF ::lActivated == .T.
      RETURN NIL
   ENDIF

   ::Create()
   ::lActivated := .T.

// Show QtObject
   ::oQTObject:Show()

// Start Qt handling
   ::sQtApplication:Exec()

RETURN NIL

/*---------------------------------------------------------------
 Create
 ---------------------------------------------------------------*/
METHOD HMGWINDOW:Create()

// TO prevent more time creation
   IF ::lActivated == .T.
      RETURN NIL
   ENDIF

// TO prevent use without QT starting
   IF ::lQtStarted == .F.
      HMGAPPLICATION():Start()
   ENDIF

// TODO HMG errors
   IF ::lStdError == .T.
      ::sQtApplication:Exit()
      ::sQtApplication:Quit()
// TODO HmgStdErr LOG
      QUIT
   ENDIF

// add HmgObject to its parent
   ::oParent:AddData( ::cName , Self )

// connecting default event
   IF ::nFormType == WND_MAIN
      IF VALTYPE( ::bOnRelease ) <> "B"
         ::oQTObject:disconnect( QEvent_Close )
         ::oQTObject:connect( QEvent_Close , {|| ::sQtApplication:Quit() } )
      ENDIF
   ELSEIF ::nFormType == WND_MODAL
      IF VALTYPE( ::bOnRelease ) <> "B"
         ::oQTObject:disconnect( QEvent_Close )
         ::oQTObject:connect( QEvent_Close , {|| ::oQTObject:Exit(), ::oQTObject:Quit() } )
      ENDIF
   ENDIF

// create child controls
   ::CreatePendingChildControls()

RETURN NIL

/*---------------------------------------------------------------
 EndWindow
 ---------------------------------------------------------------*/
METHOD HMGWINDOW:EndWindow()

   ::oDefaultParent := NIL

RETURN NIL

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD HMGWINDOW:New( oParent )

// set-up a default name
   ::cName          := '_HMG_OBJECT_' + hb_ntos( ::nObjectCounter++ )
// set-up parent in this order: parameter, current or default (last one is Qt QApplication():DeskTop()
   ::oParent := IF( hb_IsObject( oParent ), oParent, IF( hb_IsObject( ::oCurrentParent ), ::oCurrentParent, ::oDefaultParent ) )
// add this HMG object to its parent
   ::oParent:AddChild( Self )
// create QT object with its parent
   ::oQtObject := QMainWindow( ::oParent:QtObject )
// form it's now the current parent
   ::oCurrentParent := Self
// inherit font
   ::oFont     := ::oParent:QtObject:Font()
// Create system tray icon
   ::oSystemTrayIcon := QSystemTrayIcon( ::oQTObject )
// Set the focus policy to capture focus and keyboard events.
   IF ::oQTObject:focusPolicy() == Qt_NoFocus
      ::oQTObject:setFocusPolicy( Qt_StrongFocus )
   ENDIF

RETURN Self

/*................................................................
 Properties - section
 ................................................................*/
